import React from 'react';
import { Id } from '@deep-foundation/deeplinks/imports/minilinks';
export interface CytoHandlerRendererProps {
    Component: any;
    onClose?: () => any;
    [key: string]: any;
}
export interface CytoHandlerProps extends Partial<CytoHandlerRendererProps> {
    linkId: Id;
    handlerId?: Id;
    onChange?: (id: Id, handled?: {
        handlerId?: Id;
        error?: any;
        elements?: any[];
        stylesheets?: any[];
    }) => void;
    elementsById: {
        [key: string]: any;
    };
    cy?: any;
    HandleCyto?: Id;
}
export declare function useCytoHandlers(): {
    cytoHandlersRef: React.MutableRefObject<{}>;
    drawedCytoHandlers: React.MutableRefObject<{}>;
    iterator: number;
    setIterator: React.Dispatch<React.SetStateAction<number>>;
    onChange: (id: any, r: any) => void;
};
export declare function useCytoHandlersApply(cyh: any, elements: any, stylesheets: any, iterator: any): void;
export declare const CytoHandlers: React.NamedExoticComponent<{
    onChange: (id: Id, result: any) => void;
    handled: {
        [key: string]: Id;
    };
    elementsById: {
        [key: string]: any;
    };
    cy?: any;
}>;
export declare const CytoHandler: React.NamedExoticComponent<CytoHandlerProps>;
