var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { useDeep } from "@deep-foundation/deeplinks/imports/client";
import { useRefAutofill, useSpaceId } from "../hooks";
import { useMemo } from "react";
export function useOpenedMethods() {
    const [spaceId] = useSpaceId();
    const spaceIdRef = useRefAutofill(spaceId);
    const deep = useDeep();
    return useMemo(() => {
        let Opened, OpenedHandler;
        (() => __awaiter(this, void 0, void 0, function* () {
            Opened = yield deep.id('@deep-foundation/deepcase-opened', 'Opened');
            OpenedHandler = yield deep.id('@deep-foundation/deepcase-opened', 'OpenedHandler');
        }))();
        return {
            isOpened: (id) => {
                const q = deep.minilinks.query({
                    type_id: OpenedHandler,
                    from: {
                        type_id: Opened,
                        from_id: spaceIdRef.current,
                        to_id: id,
                    },
                });
                const openedHandler = q === null || q === void 0 ? void 0 : q[0];
                return !!openedHandler;
            },
            close: (id) => __awaiter(this, void 0, void 0, function* () {
                console.log('close', { spaceId, id });
                const whereF = { type_id: Opened, from_id: spaceIdRef.current, to_id: id };
                const whereFH = { type_id: OpenedHandler, from: whereF };
                const where = {
                    _or: [
                        whereF,
                        { type_id: deep.idLocal('@deep-foundation/core', 'Contain'), from_id: spaceIdRef.current, to: whereF },
                        whereFH,
                        { type_id: deep.idLocal('@deep-foundation/core', 'Contain'), from_id: spaceIdRef.current, to: whereFH },
                    ],
                };
                console.log('closeed', yield deep.delete(where));
            }),
            open: (id, handlerId) => __awaiter(this, void 0, void 0, function* () {
                var _a;
                console.log('open', { spaceId, id, handlerId });
                const q = yield deep.select({
                    type_id: OpenedHandler,
                    from: {
                        type_id: Opened,
                        from_id: spaceIdRef.current,
                        to_id: id,
                    },
                });
                const openedHandler = (_a = q === null || q === void 0 ? void 0 : q.data) === null || _a === void 0 ? void 0 : _a[0];
                let openedHandlerId = openedHandler === null || openedHandler === void 0 ? void 0 : openedHandler.id;
                if (!openedHandlerId) {
                    const { data: [{ id: newOpenId }] } = yield deep.insert({
                        type_id: Opened,
                        from_id: spaceIdRef.current,
                        to_id: id,
                        out: { data: {
                                type_id: OpenedHandler,
                                to_id: handlerId,
                                in: { data: {
                                        type_id: deep.idLocal('@deep-foundation/core', 'Contain'),
                                        from_id: spaceIdRef.current
                                    } },
                            } },
                        in: { data: {
                                type_id: deep.idLocal('@deep-foundation/core', 'Contain'),
                                from_id: spaceIdRef.current
                            } },
                    });
                    openedHandlerId = newOpenId;
                }
                else {
                    yield deep.update({
                        id: openedHandlerId,
                    }, {
                        to_id: handlerId,
                    });
                }
                console.log('opened', { spaceIdRefCurrent: spaceIdRef.current, id, handlerId, openedHandlerId: openedHandlerId });
            })
        };
    }, []);
}
;
//# sourceMappingURL=opened.js.map