import { Fragment as _Fragment, jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useDeep, useDeepId, useDeepNamespaces } from "@deep-foundation/deeplinks/imports/client";
import { useMinilinksFilter } from "@deep-foundation/deeplinks/imports/minilinks";
import React, { memo, useCallback, useEffect, useMemo } from "react";
import { useBreadcrumbs, useShowOpened } from "./hooks";
export const DeepLoaderActive = React.memo(function DeepLoaderActive({ name, mini, query: queryLink, onChange, debounce = 1000, subscription = true, deep, }) {
    var _a;
    const useLoader = deep ? subscription ? deep === null || deep === void 0 ? void 0 : deep.useDeepSubscription : deep === null || deep === void 0 ? void 0 : deep.useDeepQuery : (...args) => ({ data: [] });
    const subQueryResults = useLoader((_a = queryLink === null || queryLink === void 0 ? void 0 : queryLink.value) === null || _a === void 0 ? void 0 : _a.value, { name, mini });
    useEffect(() => {
        if (!subQueryResults.loading)
            onChange && onChange(subQueryResults === null || subQueryResults === void 0 ? void 0 : subQueryResults.data, queryLink);
    }, [subQueryResults]);
    useEffect(() => {
        return () => {
            onChange && onChange([], queryLink);
        };
    }, []);
    return _jsx(_Fragment, {});
});
export const DeepLoader = memo(function DeepLoader({ spaceId, }) {
    const deep = useDeep();
    const userId = deep.linkId;
    const namespaces = useDeepNamespaces();
    const [breadcrumbs] = useBreadcrumbs();
    const [showOpened, setShowOpened] = useShowOpened();
    const { data: HandleCyto } = useDeepId('@deep-foundation/handle-cyto', 'HandleCyto');
    const { data: Opened } = useDeepId('@deep-foundation/deepcase-opened', 'Opened');
    const { data: OpenedHandler } = useDeepId('@deep-foundation/deepcase-opened', 'OpenedHandler');
    const spaceQuery = useMemo(() => ({ value: { value: Object.assign(Object.assign({ up: {
                    tree_id: { _eq: deep.idLocal('@deep-foundation/core', 'containTree') },
                    parent_id: { _eq: spaceId },
                } }, ({
                type_id: {
                    _nin: [
                        deep.idLocal('@deep-foundation/core', 'Then'),
                        deep.idLocal('@deep-foundation/core', 'Promise'),
                        deep.idLocal('@deep-foundation/core', 'Resolved'),
                        deep.idLocal('@deep-foundation/core', 'Rejected'),
                        deep.idLocal('@deep-foundation/core', 'PromiseResult'),
                    ],
                },
            })), { _not: {
                    _and: [
                        {
                            _not: {
                                in: {
                                    type_id: deep.idLocal('@deep-foundation/core', 'Contain'),
                                    from_id: { _eq: spaceId }
                                }
                            }
                        },
                        {
                            up: {
                                tree_id: { _eq: deep.idLocal('@deep-foundation/core', 'containTree') },
                                self: { _eq: false },
                                parent: {
                                    type_id: { _in: [deep.idLocal('@deep-foundation/core', 'Space'), deep.idLocal('@deep-foundation/core', 'Package')] },
                                    up: {
                                        tree_id: { _eq: deep.idLocal('@deep-foundation/core', 'containTree') },
                                        self: { _eq: false },
                                        parent_id: { _eq: spaceId },
                                    },
                                },
                            },
                        }
                    ]
                } }) } }), []);
    const breadcrumbsQuery = useMemo(() => ({ value: { value: {
                down: {
                    tree_id: { _eq: deep.idLocal('@deep-foundation/core', 'containTree') },
                    link_id: { _eq: spaceId },
                },
            } } }), []);
    const queries = deep.useMinilinksSubscription({
        type_id: deep.idLocal('@deep-foundation/core', 'Query'),
        in: {
            type_id: deep.idLocal('@deep-foundation/core', 'Active'),
            from_id: spaceId || 0,
        },
    });
    const insertableTypesQuery = useMemo(() => ({ value: { value: {
                _or: [
                    {
                        can_object: {
                            action_id: { _eq: 121 },
                            subject_id: { _eq: userId }
                        }
                    }, {
                        type_id: { _in: [
                                deep.idLocal('@deep-foundation/core', 'Type'),
                                deep.idLocal('@deep-foundation/core', 'HandleOperation'),
                                deep.idLocal('@deep-foundation/core', 'Operation'),
                                deep.idLocal('@deep-foundation/core', 'TreeInclude'),
                                deep.idLocal('@deep-foundation/core', 'File'),
                            ] }
                    },
                ],
            } } }), [userId]);
    const notLoadedEnds = useMinilinksFilter(deep.minilinks, useCallback((l) => { var _a; return !((_a = l === null || l === void 0 ? void 0 : l._applies) === null || _a === void 0 ? void 0 : _a.includes('not-loaded-ends')); }, []), useCallback((l, ml) => (ml.links.filter(l => {
        var _a;
        return (((_a = l === null || l === void 0 ? void 0 : l._namespaces) === null || _a === void 0 ? void 0 : _a.includes('remote')) &&
            (!l._applies.includes('contains_and_symbols')
                &&
                    !!l._applies.find((a) => !!~a.indexOf('query-') || a === 'space' || a === 'breadcrumbs')
                &&
                    (!!showOpened || (!showOpened && (l === null || l === void 0 ? void 0 : l.type_id) !== Opened && (l === null || l === void 0 ? void 0 : l.type_id) !== OpenedHandler))) && ((!!l.from_id && (!l.from || !!l.from._applies.includes('not-loaded-ends')))
            ||
                (!!l.to_id && (!l.to || !l.to._applies.includes('not-loaded-ends')))));
    })), []), 1000) || [];
    const notLoadedEndsQuery = useMemo(() => {
        return { value: { value: {
                    id: { _in: [
                            ...notLoadedEnds.map(l => l.from_id).filter(id => !!id),
                            ...notLoadedEnds.map(l => l.to_id).filter(id => !!id),
                        ] },
                } } };
    }, [notLoadedEnds]);
    const notLoadedEndsCyber = useMinilinksFilter(deep.minilinks, useCallback((l) => { var _a, _b; return (!((_a = l === null || l === void 0 ? void 0 : l._applies) === null || _a === void 0 ? void 0 : _a.includes('not-loaded-ends-cyber')) && ((_b = l === null || l === void 0 ? void 0 : l._namespaces) === null || _b === void 0 ? void 0 : _b.includes('cyber'))); }, []), useCallback((l, ml) => (ml.links.filter(l => {
        var _a;
        return (((_a = l === null || l === void 0 ? void 0 : l._namespaces) === null || _a === void 0 ? void 0 : _a.includes('cyber'))
            &&
                ((!!l.from_id && (!l.from || !!l.from._applies.includes('not-loaded-ends-cyber')))
                    ||
                        (!!l.to_id && (!l.to || !!l.to._applies.includes('not-loaded-ends-cyber')))));
    })), []), 1000) || [];
    const notLoadedEndsCyberQuery = useMemo(() => {
        return { value: { value: {
                    id: { _in: [
                            ...notLoadedEndsCyber.map(l => l.from_id).filter(id => !!id),
                            ...notLoadedEndsCyber.map(l => l.to_id).filter(id => !!id),
                        ] },
                } } };
    }, [notLoadedEndsCyber]);
    const treesQuery = useMemo(() => {
        return { value: { value: {
                    type_id: deep.idLocal('@deep-foundation/core', 'Tree'),
                } } };
    }, [notLoadedEnds]);
    const typeIds = useMinilinksFilter(deep.minilinks, useCallback((l) => true, []), useCallback((l, ml) => {
        return Object.keys(ml.byType).filter(id => typeof (+id) === 'number' && !Number.isNaN(+id));
    }, []), 1000) || [];
    const treeIds = useMinilinksFilter(deep.minilinks, useCallback((l) => true, []), useCallback((l, ml) => {
        var _a, _b;
        return ((_b = (_a = ml.byType) === null || _a === void 0 ? void 0 : _a[deep.idLocal('@deep-foundation/core', 'Tree')]) === null || _b === void 0 ? void 0 : _b.map(l => l.id)) || [];
    }, []), 1000) || [];
    const ids = useMinilinksFilter(deep.minilinks, useCallback((l) => true, []), useCallback((l, ml) => {
        return Object.keys(ml.byId).filter(id => typeof (+id) === 'number' && !Number.isNaN(+id));
    }, []), 1000) || [];
    const queryAndSpaceLoadedIdsFilter = useCallback((l) => { var _a, _b; return !!((_a = l === null || l === void 0 ? void 0 : l._namespaces) === null || _a === void 0 ? void 0 : _a.includes('remote')) && (!!((_b = l === null || l === void 0 ? void 0 : l._applies) === null || _b === void 0 ? void 0 : _b.find(a => a.includes('query-') || a.includes('space') || a.includes('client-handlers')))); }, []);
    const queryAndSpaceLoadedIds = useMinilinksFilter(deep.minilinks, useCallback(queryAndSpaceLoadedIdsFilter, []), useCallback((l, ml) => (ml.links.filter(queryAndSpaceLoadedIdsFilter).map(l => l.id)), []), 1000) || [];
    const containsAndSymbolsQuery = useMemo(() => {
        const ids = [...typeIds, ...queryAndSpaceLoadedIds, ...treeIds];
        return { value: { value: {
                    to_id: { _in: ids },
                    type_id: { _in: [deep.idLocal('@deep-foundation/core', 'Contain'), deep.idLocal('@deep-foundation/core', 'Symbol')] },
                } } };
    }, [typeIds, queryAndSpaceLoadedIds, treeIds]);
    const valuesQuery = useMemo(() => {
        const ids = [...typeIds, ...queryAndSpaceLoadedIds];
        return { value: { value: {
                    from_id: { _in: ids },
                    type_id: { _eq: deep.idLocal('@deep-foundation/core', 'Value') },
                } } };
    }, [typeIds, queryAndSpaceLoadedIds]);
    const typesQuery = useMemo(() => {
        return { value: { value: {
                    down: {
                        tree_id: { _eq: deep.idLocal('@deep-foundation/core', 'typesTree') },
                        link_id: { _in: ids },
                        parent_id: { _nin: ids },
                    },
                } } };
    }, [ids]);
    const clientHandlersQuery = useMemo(() => {
        const _ids = [...ids, ...queryAndSpaceLoadedIds];
        const handles = { _in: [deep.idLocal('@deep-foundation/core', 'HandleClient'), HandleCyto] };
        return { value: { value: {
                    _or: [
                        {
                            in: {
                                type_id: deep.idLocal('@deep-foundation/core', 'Handler'),
                                in: {
                                    type_id: handles,
                                },
                            },
                        },
                        {
                            type_id: deep.idLocal('@deep-foundation/core', 'Handler'),
                            in: {
                                type_id: handles,
                            },
                        },
                        { type_id: handles },
                    ]
                } } };
    }, [queryAndSpaceLoadedIds, ids]);
    const handleCytoCode = useMemo(() => {
        const _ids = [...ids, ...queryAndSpaceLoadedIds];
        return { value: { value: {
                    _or: [
                        {
                            type_id: deep.idLocal('@deep-foundation/core', 'Handler'),
                            in: {
                                type_id: { _in: deep.idLocal('@deep-foundation/core', 'HandleClient'), HandleCyto },
                            },
                        },
                        { type_id: deep.idLocal('@deep-foundation/core', 'HandleClient') },
                    ]
                } } };
    }, [queryAndSpaceLoadedIds, ids]);
    return _jsxs(_Fragment, { children: [_jsx(_Fragment, { children: _jsx(DeepLoaderActive, { name: "DEEPCASE_SPACE", deep: deep, query: spaceQuery, mini: 'space' }, "DEEPCASE_SPACE") }), _jsx(_Fragment, { children: _jsx(DeepLoaderActive, { name: "DEEPCASE_TREES", deep: deep, query: treesQuery, mini: 'trees' }, "DEEPCASE_TREES") }), _jsx(_Fragment, { children: _jsx(DeepLoaderActive, { name: "DEEPCASE_NOT_LOADED_ENDS", deep: deep, query: notLoadedEndsQuery, mini: 'not-loaded-ends' }, "DEEPCASE_NOT_LOADED_ENDS") }), !!(namespaces === null || namespaces === void 0 ? void 0 : namespaces.cyber) && _jsx(_Fragment, { children: _jsx(DeepLoaderActive, { name: "DEEPCASE_NOT_LOADED_ENDS_CYBER", deep: namespaces === null || namespaces === void 0 ? void 0 : namespaces.cyber, query: notLoadedEndsCyberQuery, mini: 'not-loaded-ends-cyber' }, "DEEPCASE_NOT_LOADED_ENDS_CYBER") }), !!breadcrumbs && _jsx(_Fragment, { children: _jsx(DeepLoaderActive, { name: "DEEPCASE_BREADCRUMBS", deep: deep, query: breadcrumbsQuery, mini: 'breadcrumbs' }, "DEEPCASE_BREADCRUMBS") }), _jsx(_Fragment, { children: _jsx(DeepLoaderActive, { name: "DEEPCASE_CLIENT_HANDLERS", deep: deep, query: clientHandlersQuery, mini: 'client-handlers' }, "DEEPCASE_CLIENT_HANDLERS") }), useMemo(() => {
                return queries === null || queries === void 0 ? void 0 : queries.map((f, i) => {
                    var _a;
                    return (((_a = f === null || f === void 0 ? void 0 : f.value) === null || _a === void 0 ? void 0 : _a.value) ? _jsx(React.Fragment, { children: Object.values(namespaces).map(deep => _jsx(DeepLoaderActive, { name: `DEEPCASE_QUERY_${deep === null || deep === void 0 ? void 0 : deep.namespace}_${`${f.id}`.replace('-', 'virtual')}`, deep: deep, query: f, mini: `query-${`${f.id}`.replace('-', 'virtual')}` }, `DEEPCASE_QUERY_${deep === null || deep === void 0 ? void 0 : deep.namespace}_${`${f.id}`.replace('-', 'virtual')}`)) }, `DEEPCASE_QUERY_${f.id}`) : _jsx(React.Fragment, {}, `DEEPCASE_QUERY_${`${f.id}`.replace('-', 'virtual')}`));
                });
            }, [namespaces, queries]), _jsx(_Fragment, { children: _jsx(DeepLoaderActive, { name: `DEEPCASE_TYPES`, deep: deep, query: typesQuery, mini: 'types' }, `DEEPCASE_TYPES`) }), !!typeIds && _jsx(_Fragment, { children: _jsx(DeepLoaderActive, { name: `DEEPCASE_CONTAINS_AND_SYMBOLS`, deep: deep, query: containsAndSymbolsQuery, debounce: 2000, mini: 'contains_and_symbols' }, `DEEPCASE_CONTAINS_AND_SYMBOLS`) }), !!typeIds && _jsx(_Fragment, { children: _jsx(DeepLoaderActive, { name: `DEEPCASE_VALUES`, deep: deep, query: valuesQuery, mini: 'values' }, `DEEPCASE_VALUES`) })] });
});
//# sourceMappingURL=loader.js.map