import React from 'react';
import { Id } from '@deep-foundation/deeplinks/imports/minilinks';
export interface IPackageInstalledVersion {
    id: Id;
    version: string;
    packageId: Id;
    isActive: boolean;
}
export interface IPackage {
    id: Id;
    name: string;
    description?: any;
    versions?: IPackageInstalledVersion[];
}
interface IPackageProps extends IPackage {
    i?: number;
    expanded?: boolean | number;
    onOpen?: (e: any) => any;
    style?: any;
    animate?: any;
    variants?: any;
    transition?: any;
    latestVersion?: string;
}
export type Package = IPackage[];
export declare const ListVersions: React.MemoExoticComponent<({ name, latestVersion, currentVersion, bg, setCurrentVersion }: {
    name: string;
    latestVersion: string;
    currentVersion: string;
    setCurrentVersion: (string) => any;
    bg: string;
}) => import("react/jsx-runtime").JSX.Element>;
export declare const PackageItem: React.NamedExoticComponent<IPackageProps>;
export declare const TabComponent: React.MemoExoticComponent<({ variant, installedPackages, notInstalledPackages, }: {
    variant?: number;
    installedPackages: any[];
    notInstalledPackages: any[];
}) => import("react/jsx-runtime").JSX.Element>;
export {};
