import { Fragment as _Fragment, jsx as _jsx } from "react/jsx-runtime";
import { TokenProvider, useTokenController } from '@deep-foundation/deeplinks/imports/react-token';
import { ApolloClientTokenizedProvider } from '@deep-foundation/react-hasura/apollo-client-tokenized-provider';
import { LocalStoreProvider } from '@deep-foundation/store/local';
import { QueryStoreProvider } from '@deep-foundation/store/query';
import { CookiesStoreProvider } from '@deep-foundation/store/cookies';
import { ChakraProvider } from '@chakra-ui/react';
import themeChakra from './theme/theme';
import { useMemo } from 'react';
export function ProviderConnected({ children, }) {
    const [token, setToken] = useTokenController();
    return _jsx(_Fragment, { children: children });
}
export function StaticProviders({ children, }) {
    return _jsx(_Fragment, { children: _jsx(QueryStoreProvider, { children: _jsx(CookiesStoreProvider, { children: _jsx(LocalStoreProvider, { children: _jsx(TokenProvider, { children: children }) }) }) }) });
}
export function Provider({ gqlPath, gqlSsl, children, }) {
    const ThemeProviderCustom = ChakraProvider;
    const themeCustom = themeChakra;
    return (_jsx(_Fragment, { children: _jsx(ThemeProviderCustom, { theme: themeCustom, children: _jsx(ApolloClientTokenizedProvider, { options: useMemo(() => ({
                    client: 'deeplinks-app', path: gqlPath, ssl: gqlSsl, ws: !!(process === null || process === void 0 ? void 0 : process.browser),
                    fetchPolicy: 'no-cache',
                    query: {
                        fetchPolicy: 'no-cache',
                    },
                    watchQuery: {
                        fetchPolicy: 'no-cache',
                    },
                }), [gqlPath, gqlSsl]), children: _jsx(ProviderConnected, { children: children }) }) }) }));
}
;
//# sourceMappingURL=provider.js.map